#ifndef BEZIER_H
#define BEZIER_H

template<typename T>
T mix(const T& a, const T& b, float t)
{
    if(t <= 0) return a;
    if(t >= 1) return b;
    return a + t * (b - a);
}

template<typename iterator>
typename iterator::value_type bezier(iterator begin, iterator end, const float t)
{
    if(std::distance(begin, end) == 1) 
        return mix(*begin, *end, t);

    return mix(bezier(begin, end-1, t), bezier(begin+1, end, t), t);
}

#endif