#pragma once

#include "volumetricpathtracingintegrator.h"

class MISMultiViewPathTracingIntegrator : public VolumetricPathTracingIntegrator
{
public:
    MISMultiViewPathTracingIntegrator(
        std::vector<Camera>&      aCameras,
        Builder&                  aBuilder,
        const IntegratorConfig&   aConfig
    );

    struct PathPrefixData
    {
        CameraSample cameraSample; // contains ray, pdf, lens sample, film position, weight
        MediumRecords records;
        std::vector<MediumSample> mediumSamplesChain;
        Color color = Black();
        Color weight = White();
        Color tr = White();
        Vector wo;
        float pdf = 0;
        float cameraPdf = 1;
        float mediumPdf = 1;
        float geoTermPdf = 1;
        float misWeight = 1;
        float alpha = 1;
        float ni = 1;
        float ci = 1;
        float n = 1;
        float pdf_initial_to_me = 0;

        float imageWeight = 1;
    };

    void Render() override;

    void SaveRenders() const override;

};
