#pragma once

#include "abstractintegrator.h"

class VolumetricPathTracingIntegrator : public AbstractIntegrator 
{
public:
    VolumetricPathTracingIntegrator( 
        std::vector<Camera>&      aCameras, 
        Builder&                  aBuilder, 
        const IntegratorConfig&   aConfig 
    );
    
    ~VolumetricPathTracingIntegrator(){}
    
    void Render();
    
    bool SampleAndEvalPath(
        Color& color,
        Ray& ray,
        Sampler& sampler,
        Color& pathWeight,
        MediumRecords& records,
        int pathLength = 0,
        float lastPdfW = 0,
        float last_ratio_DT_RT = 0,
        float last_pdf_EA = 0
    );
    
    Color SampleEquiangularDirect( 
        Sampler& sampler, 
        const MediumRecords& records 
    );
    
    // Color SampleDirect( Sampler& sampler, const Color& pathWeight, const MediumRecords& records, std::shared_ptr<Bsdf> bsdf )
    
};